import sys
import bz2
import cPickle
import subprocess

def save(filename,myobj):
    """save the myobj to filename using pickle"""
    try:
        f = bz2.BZ2File(filename,'wb')
    except IOError:
        sys.stderr.write('File ' + filename + ' cannot be written\n')
        return

    cPickle.dump(myobj,f,protocol=2)
    f.close()


def load(filename):
    """load the myobj from filename using pickle"""
    try:
        f = bz2.BZ2File(filename,'rb')
    except IOError:
        sys.stderr.write('File ' + filename + ' cannot be read\n')
        return

    myobj = cPickle.load(f)
    f.close()
    return myobj

def convert_v6(input_filename,output_filename):
   """ starts matlab and converts a structure to a matlab v6 structure """

   cmd = "matlab -nojvm -nodisplay -r \"load %s; save -v6 '%s'; exit\"" % (input_filename,output_filename)
   obj = subprocess.Popen(cmd,shell=True,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
   out,err = obj.communicate()
   assert err == '', 'An error occured!\n%s'%err
